"use strict";var Buffer=require("safe-buffer").Buffer,crypto=require("../crypto"),cs=require("./coinstring"),secp256k1=require("../secp256k1"),MASTER_SECRET=Buffer.from("Bitcoin seed","utf8"),HARDENED_OFFSET=2147483648,LEN=78,BITCOIN_VERSIONS={private:76066276,public:76067358};function HDKey(e){this.versions=e||BITCOIN_VERSIONS,this.depth=0,this.index=0,this._privateKey=null,this._publicKey=null,this.chainCode=null,this._fingerprint=0,this.parentFingerprint=0}function serialize(e,t,i){var r=Buffer.allocUnsafe(LEN);r.writeUInt32BE(t,0),r.writeUInt8(e.depth,4);var n=e.depth?e.parentFingerprint:0;return r.writeUInt32BE(n,5),r.writeUInt32BE(e.index,9),e.chainCode.copy(r,13),i.copy(r,45),r}function hash160(e){var t=crypto.createHash("sha256").update(e).digest();return crypto.createHash("ripemd160").update(t).digest()}Object.defineProperty(HDKey.prototype,"fingerprint",{get:function(){return this._fingerprint}}),Object.defineProperty(HDKey.prototype,"identifier",{get:function(){return this._identifier}}),Object.defineProperty(HDKey.prototype,"pubKeyHash",{get:function(){return this.identifier}}),Object.defineProperty(HDKey.prototype,"privateKey",{get:function(){return this._privateKey},set:function(e){this._privateKey=e,this._publicKey=secp256k1.publicKeyCreate(e,!0),this._identifier=hash160(this.publicKey),this._fingerprint=this._identifier.slice(0,4).readUInt32BE(0)}}),Object.defineProperty(HDKey.prototype,"publicKey",{get:function(){return this._publicKey},set:function(e){this._publicKey=secp256k1.publicKeyConvert(e,!0),this._identifier=hash160(this.publicKey),this._fingerprint=this._identifier.slice(0,4).readUInt32BE(0),this._privateKey=null}}),Object.defineProperty(HDKey.prototype,"privateExtendedKey",{get:function(){return this._privateKey?cs.encode(serialize(this,this.versions.private,Buffer.concat([Buffer.alloc(1,0),this.privateKey]))):null}}),Object.defineProperty(HDKey.prototype,"publicExtendedKey",{get:function(){return cs.encode(serialize(this,this.versions.public,this.publicKey))}}),HDKey.prototype.derive=function(e){if("m"===e||"M"===e||"m'"===e||"M'"===e)return this;var t=e.split("/"),n=this;return t.forEach(function(e,t){if(0!==t){var i=1<e.length&&"'"===e[e.length-1],r=parseInt(e,10);i&&(r+=HARDENED_OFFSET),n=n.deriveChild(r)}}),n},HDKey.prototype.deriveChild=function(t){var e,i=HARDENED_OFFSET<=t,r=Buffer.allocUnsafe(4);if(r.writeUInt32BE(t,0),i){var n=this.privateKey,p=Buffer.alloc(1,0);n=Buffer.concat([p,n]),e=Buffer.concat([n,r])}else e=Buffer.concat([this.publicKey,r]);var s=crypto.createHmac("sha512",this.chainCode).update(e).digest(),c=s.slice(0,32),y=s.slice(32),o=new HDKey(this.versions);if(this.privateKey)try{o.privateKey=secp256k1.privateKeyTweakAdd(this.privateKey,c)}catch(e){return this.derive(t+1)}else try{o.publicKey=secp256k1.publicKeyTweakAdd(this.publicKey,c,!0)}catch(e){return this.derive(t+1,i)}return o.chainCode=y,o.depth=this.depth+1,o.parentFingerprint=this.fingerprint,o.index=t,o},HDKey.prototype.sign=function(e){return secp256k1.sign(e,this.privateKey).signature},HDKey.prototype.verify=function(e,t){return secp256k1.verify(e,t,this.publicKey)},HDKey.prototype.wipePrivateData=function(){return this._privateKey&&crypto.randomBytes(this._privateKey.length).copy(this._privateKey),this._privateKey=null,this},HDKey.prototype.toJSON=function(){return{xpriv:this.privateExtendedKey,xpub:this.publicExtendedKey}},HDKey.fromMasterSeed=function(e,t){var i=crypto.createHmac("sha512",MASTER_SECRET).update(e).digest(),r=i.slice(0,32),n=i.slice(32),p=new HDKey(t);return p.chainCode=n,p.privateKey=r,p},HDKey.fromExtendedKey=function(e,t){var i=new HDKey(t=t||BITCOIN_VERSIONS),r=cs.decode(e);r.readUInt32BE(0);i.depth=r.readUInt8(4),i.parentFingerprint=r.readUInt32BE(5),i.index=r.readUInt32BE(9),i.chainCode=r.slice(13,45);var n=r.slice(45);return 0===n.readUInt8(0)?i.privateKey=n.slice(1):i.publicKey=n,i},HDKey.fromJSON=function(e){return HDKey.fromExtendedKey(e.xpriv)},HDKey.HARDENED_OFFSET=HARDENED_OFFSET,module.exports=HDKey;