"use strict";var secp256k1=require("../crypto/secp256k1"),CryptoJS=require("crypto-js"),paramUtil=require("./param"),Buffer=require("safe-buffer").Buffer,PEM=require("./pem"),ECKey=require("./eckey"),RSA=require("../crypto/publicEncrypt/browser"),AES=require("browserify-aes/browser"),createHash=require("create-hash"),Base64x=require("../crypto/base64x"),bip39=require("../crypto/bip39/index"),HDKey=require("../crypto/hdkey/index"),jseu=require("js-encoding-utils"),RandomBytes=require("../crypto/publicEncrypt/randombytes"),ecies=require("../crypto/publicEncrypt/browser_ecies"),EncryptionType=require("../config/encryptionType");module.exports={getKeyInfo:function(e,r){if(r)return this.getKeyInfoFromPEM(e,r);if("string"==typeof e){var t=paramUtil.toBuffer(e),a=secp256k1.publicKeyCreate(t,!1);return 64<a.length&&(a=a.slice(1)),{privateKey:t,publicKey:a}}},getKeyInfoFromPEM:function(e,r){var t=PEM(e,"EC PRIVATE KEY",r).pem,a=new ECKey(t,"pem"),i=a.d,n=a.publicCodePoint;return 64<n.length&&(n=n.slice(1)),{privateKey:i,publicKey:n}},generateECKey:function(){for(var e,r=CryptoJS.lib.WordArray.random(32);e=paramUtil.toBuffer(r.toString(CryptoJS.enc.Hex)),!secp256k1.privateKeyVerify(e););var t=secp256k1.publicKeyCreate(e,!1);return 64<t.length&&(t=t.slice(1)),{privateKey:e,publicKey:t}},sign:function(e,r){paramUtil.isBuffer(e)?32!==e.length&&(e=paramUtil.toBuffer(paramUtil.getHash(e))):e=paramUtil.isString(e)&&0===e.indexOf("0x")?paramUtil.toBuffer(e):paramUtil.toBuffer(paramUtil.getHash(e));var t=secp256k1.sign(e,r);return Buffer.concat([t.signature,Buffer.from([t.recovery])],65)},generateAESKey:function(e,r){if(!e||!r)throw new Error("aes password or tx hash is invalid"+e+"..."+r);if(paramUtil.isString(e)&&(e="0x"===e.substr(0,2)?Buffer.from(e.substr(2),"hex"):Buffer.from(e,"ascii")),!paramUtil.isBuffer(e))throw new Error("aes password is invalid");return r=paramUtil.hexToBuffer(r),createHash("sha256").update(Buffer.concat([e,r])).digest().slice(0,16)},randomBytes:function(e){if("number"!=typeof e)throw new Error("param is not number.");return paramUtil.bufferToHex(RandomBytes(e))},randomNumber:function(){return RandomBytes(4).readUInt32BE(0)},sealSGXWithPassword:function(e,r,t,a,i){return i===EncryptionType.ECIES?this.sealEccSGX(e,r,this.generateAESKey(t,a)):this.sealRsaSGX(e,r,this.generateAESKey(t,a))},sealRsaSGX:function(e,r,t){if(t||(t=RandomBytes(16)),t=paramUtil.hexToBuffer(t),!e)throw new Error("rsa_pub_key is invalid");paramUtil.isString(e)&&-1===e.indexOf("PUBLIC KEY")&&("0x"===e.substr(0,2)&&(e=e.substr(2)),e=Base64x.hextopem(e,"PUBLIC KEY"));var a=RandomBytes(12),i=this.encryptAES(r,t,a),n=RSA.publicEncrypt(e,t);if(n.length<256){var o=Buffer.alloc(256);n.copy(o,256-n.length),n=o}var f=new Buffer(2);return f.writeUInt16BE(1),"0x"+Buffer.concat([f,n,a,Buffer.from(i.authTag,"hex"),Buffer.from(i.data,"hex")]).toString("hex")},sealEccSGX:function(e,r,t){if(!e)throw new Error("ecc_pub_key is invalid");t||(t=RandomBytes(16)),t=paramUtil.hexToBuffer(t);var a=RandomBytes(12),i=this.encryptAES(r,t,a),n=Buffer.from(i.authTag,"hex"),o=Buffer.from(i.data,"hex"),f={iv:a},u=jseu.formatter.pemToBin(e.toString()),s=Buffer.from(u);e=s.slice(s.byteLength-65,s.byteLength),e=paramUtil.hexToBuffer(e);var p=ecies.encrypt(e,t,f);if(p.length<109){var c=Buffer.alloc(109);p.copy(c,109-p.length),p=c}var h=new Buffer(2);return h.writeUInt16BE(320),p=paramUtil.hexToBuffer(p),"0x"+Buffer.concat([h,p,a,n,o]).toString("hex")},encryptAES:function(e,r,t){if(!r||!t)throw new Error("aes empty key or iv!");e=paramUtil.hexToBuffer(e),r=paramUtil.hexToBuffer(r);var a=AES.createCipheriv("aes-128-gcm",r,t);a.setAutoPadding(!1);var i=a.update(e).toString("hex");return a.final(),{data:i,authTag:a.getAuthTag().toString("hex")}},decryptAES:function(e,r){if(!r||!e)throw new Error("aes empty key or data!");e=paramUtil.hexToBuffer(e),r=paramUtil.hexToBuffer(r);var t=e.length-16,a=e.length,i=e.slice(t,a);t-=12,a-=16;var n=e.slice(t,a),o=e.slice(0,t),f=AES.createDecipheriv("aes-128-gcm",r,n);return f.setAuthTag(i),"0x"+f.update(o).toString("hex")},decryptAESWithIV:function(e,r,t,a){if(!r||!t||!a)throw new Error("aes empty key or iv or tag!");e=paramUtil.hexToBuffer(e),r=paramUtil.hexToBuffer(r),t=paramUtil.hexToBuffer(t),a=paramUtil.hexToBuffer(a);var i=AES.createDecipheriv("aes-128-gcm",r,t);return i.setAuthTag(a),"0x"+i.update(e).toString("hex")},decryptAESWithPassword:function(e,r,t){return this.decryptAES(e,this.generateAESKey(r,t))},decryptAESTX:function(e,r){if(!r||!e)throw new Error("aes empty key or data!");e=paramUtil.hexToBuffer(e),r=paramUtil.hexToBuffer(r);var t=0,a=12,i=e.slice(t,a);t+=12,a+=16;var n=e.slice(t,a);t+=16,a=e.length;var o=e.slice(t,a),f=AES.createDecipheriv("aes-128-gcm",r,i);return f.setAuthTag(n),"0x"+f.update(o).toString("hex")},bip39:bip39,HDKey:HDKey};